# PrestaShop\Module\PrestaConnector\pol\api\lib\ConfigApi

All URIs are relative to https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api/WebConnect, except if the operation defines another base path.

| Method | HTTP request | Description |
| ------------- | ------------- | ------------- |
| [**configGetStruture()**](ConfigApi.md#configGetStruture) | **GET** /Config/Struture | Obtient les informations sur le connecteur mis à disposition par ces API |
| [**configGetWebCatalogApp()**](ConfigApi.md#configGetWebCatalogApp) | **GET** /Config/WebCatalogApp | Obtient la configuration sur le WebCatalog si cet accès est paramétré pour l&#39;utilisation d&#39;un catalogue Web |


## `configGetStruture()`

```php
configGetStruture(): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\InfoConnect
```

Obtient les informations sur le connecteur mis à disposition par ces API

Obtient les informations sur le connecteur mis à disposition par ces API

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ConfigApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);

try {
    $result = $apiInstance->configGetStruture();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ConfigApi->configGetStruture: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\InfoConnect**](../Model/InfoConnect.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `configGetWebCatalogApp()`

```php
configGetWebCatalogApp(): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\InfoCatalogue
```

Obtient la configuration sur le WebCatalog si cet accès est paramétré pour l'utilisation d'un catalogue Web

Obtient la configuration sur le WebCatalog si cet accès est paramétré pour l'utilisation d'un catalogue Web

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\ConfigApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);

try {
    $result = $apiInstance->configGetWebCatalogApp();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ConfigApi->configGetWebCatalogApp: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\InfoCatalogue**](../Model/InfoCatalogue.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)
