<?php
/**
 * MediaApi
 * PHP version 7.4
 *
 * @category Class
 * @package  PrestaShop\Module\PolarisPrestaConnector\pol\api\lib
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Polaris WebConnect
 *
 * L'API WebConnect vous permet d'interconnecter facilement votre solution Polaris avec un site Internet en permettant à ce dernier de télécharger votre catalogue, vos clients, votre fidélité       *Pour rappel, la spécification OpenAPI est une spécification de fichiers d'interface lisibles par une machine pour décrire, produire, consommer et visualiser les services Web REST de manière automatisée. Vous pouvez donc utiliser des outils comme [Swagger](https://editor.swagger.io/) pour générer automatiquement une bibliothèque cliente dans le langage de votre choix.*    **Voir la documentation générale : [https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect)**
 *
 * The version of the OpenAPI document: 13.1.99.65534
 * Contact: assistance@vega-info.fr
 * Generated by: https://openapi-generator.tech
 * Generator version: 7.8.0
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\ConnectException;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException;
use PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Configuration;
use PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\HeaderSelector;
use PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ObjectSerializer;

/**
 * MediaApi Class Doc Comment
 *
 * @category Class
 * @package  PrestaShop\Module\PolarisPrestaConnector\pol\api\lib
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class MediaApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /** @var string[] $contentTypes **/
    public const contentTypes = [
        'mediaGetPhoto' => [
            'application/json',
        ],
        'mediaPutUrl' => [
            'application/json',
        ],
    ];

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $hostIndex (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $hostIndex = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $hostIndex;
    }

    /**
     * Set the host index
     *
     * @param int $hostIndex Host index (required)
     */
    public function setHostIndex($hostIndex): void
    {
        $this->hostIndex = $hostIndex;
    }

    /**
     * Get the host index
     *
     * @return int Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation mediaGetPhoto
     *
     * Obtient la photo correspondant à l&#39;identifiant fourni
     *
     * @param  int $no_photo Numéro de la photo que vous souhaitez obtenir (required)
     * @param  PhotoSize $photo_size Taille de l&#39;image souhaitée, si non spécifiée, renvoi la taille paramétrée sur le système (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaGetPhoto'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return void
     */
    public function mediaGetPhoto($no_photo, $photo_size = null, string $contentType = self::contentTypes['mediaGetPhoto'][0])
    {
        $this->mediaGetPhotoWithHttpInfo($no_photo, $photo_size, $contentType);
    }

    /**
     * Operation mediaGetPhotoWithHttpInfo
     *
     * Obtient la photo correspondant à l&#39;identifiant fourni
     *
     * @param  int $no_photo Numéro de la photo que vous souhaitez obtenir (required)
     * @param  PhotoSize $photo_size Taille de l&#39;image souhaitée, si non spécifiée, renvoi la taille paramétrée sur le système (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaGetPhoto'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function mediaGetPhotoWithHttpInfo($no_photo, $photo_size = null, string $contentType = self::contentTypes['mediaGetPhoto'][0])
    {
        $request = $this->mediaGetPhotoRequest($no_photo, $photo_size, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation mediaGetPhotoAsync
     *
     * Obtient la photo correspondant à l&#39;identifiant fourni
     *
     * @param  int $no_photo Numéro de la photo que vous souhaitez obtenir (required)
     * @param  PhotoSize $photo_size Taille de l&#39;image souhaitée, si non spécifiée, renvoi la taille paramétrée sur le système (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaGetPhoto'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function mediaGetPhotoAsync($no_photo, $photo_size = null, string $contentType = self::contentTypes['mediaGetPhoto'][0])
    {
        return $this->mediaGetPhotoAsyncWithHttpInfo($no_photo, $photo_size, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation mediaGetPhotoAsyncWithHttpInfo
     *
     * Obtient la photo correspondant à l&#39;identifiant fourni
     *
     * @param  int $no_photo Numéro de la photo que vous souhaitez obtenir (required)
     * @param  PhotoSize $photo_size Taille de l&#39;image souhaitée, si non spécifiée, renvoi la taille paramétrée sur le système (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaGetPhoto'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function mediaGetPhotoAsyncWithHttpInfo($no_photo, $photo_size = null, string $contentType = self::contentTypes['mediaGetPhoto'][0])
    {
        $returnType = '';
        $request = $this->mediaGetPhotoRequest($no_photo, $photo_size, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'mediaGetPhoto'
     *
     * @param  int $no_photo Numéro de la photo que vous souhaitez obtenir (required)
     * @param  PhotoSize $photo_size Taille de l&#39;image souhaitée, si non spécifiée, renvoi la taille paramétrée sur le système (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaGetPhoto'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function mediaGetPhotoRequest($no_photo, $photo_size = null, string $contentType = self::contentTypes['mediaGetPhoto'][0])
    {

        // verify the required parameter 'no_photo' is set
        if ($no_photo === null || (is_array($no_photo) && count($no_photo) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $no_photo when calling mediaGetPhoto'
            );
        }



        $resourcePath = '/Media/Photo';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $no_photo,
            'noPhoto', // param base name
            'integer', // openApiType
            'form', // style
            true, // explode
            true // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $photo_size,
            'photoSize', // param base name
            'PhotoSize', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);




        $headers = $this->headerSelector->selectHeaders(
            ['image', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation mediaPutUrl
     *
     * Poste les URL du site
     *
     * @param  string $sku Code Polaris, Gencod Fournisseur ou GTIN (required)
     * @param  MediaTypeUrl $type_url Type de URL (required)
     * @param  string $body Url complète de la photo ou du produit sur le site  (url) (required)
     * @param  int $index Index de la photo (optional, default to 0)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaPutUrl'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return void
     */
    public function mediaPutUrl($sku, $type_url, $body, $index = 0, string $contentType = self::contentTypes['mediaPutUrl'][0])
    {
        $this->mediaPutUrlWithHttpInfo($sku, $type_url, $body, $index, $contentType);
    }

    /**
     * Operation mediaPutUrlWithHttpInfo
     *
     * Poste les URL du site
     *
     * @param  string $sku Code Polaris, Gencod Fournisseur ou GTIN (required)
     * @param  MediaTypeUrl $type_url Type de URL (required)
     * @param  string $body Url complète de la photo ou du produit sur le site  (url) (required)
     * @param  int $index Index de la photo (optional, default to 0)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaPutUrl'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function mediaPutUrlWithHttpInfo($sku, $type_url, $body, $index = 0, string $contentType = self::contentTypes['mediaPutUrl'][0])
    {
        $request = $this->mediaPutUrlRequest($sku, $type_url, $body, $index, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation mediaPutUrlAsync
     *
     * Poste les URL du site
     *
     * @param  string $sku Code Polaris, Gencod Fournisseur ou GTIN (required)
     * @param  MediaTypeUrl $type_url Type de URL (required)
     * @param  string $body Url complète de la photo ou du produit sur le site  (url) (required)
     * @param  int $index Index de la photo (optional, default to 0)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaPutUrl'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function mediaPutUrlAsync($sku, $type_url, $body, $index = 0, string $contentType = self::contentTypes['mediaPutUrl'][0])
    {
        return $this->mediaPutUrlAsyncWithHttpInfo($sku, $type_url, $body, $index, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation mediaPutUrlAsyncWithHttpInfo
     *
     * Poste les URL du site
     *
     * @param  string $sku Code Polaris, Gencod Fournisseur ou GTIN (required)
     * @param  MediaTypeUrl $type_url Type de URL (required)
     * @param  string $body Url complète de la photo ou du produit sur le site  (url) (required)
     * @param  int $index Index de la photo (optional, default to 0)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaPutUrl'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function mediaPutUrlAsyncWithHttpInfo($sku, $type_url, $body, $index = 0, string $contentType = self::contentTypes['mediaPutUrl'][0])
    {
        $returnType = '';
        $request = $this->mediaPutUrlRequest($sku, $type_url, $body, $index, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'mediaPutUrl'
     *
     * @param  string $sku Code Polaris, Gencod Fournisseur ou GTIN (required)
     * @param  MediaTypeUrl $type_url Type de URL (required)
     * @param  string $body Url complète de la photo ou du produit sur le site  (url) (required)
     * @param  int $index Index de la photo (optional, default to 0)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['mediaPutUrl'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function mediaPutUrlRequest($sku, $type_url, $body, $index = 0, string $contentType = self::contentTypes['mediaPutUrl'][0])
    {

        // verify the required parameter 'sku' is set
        if ($sku === null || (is_array($sku) && count($sku) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $sku when calling mediaPutUrl'
            );
        }

        // verify the required parameter 'type_url' is set
        if ($type_url === null || (is_array($type_url) && count($type_url) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $type_url when calling mediaPutUrl'
            );
        }

        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling mediaPutUrl'
            );
        }



        $resourcePath = '/Media/Url';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $sku,
            'sku', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            true // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $type_url,
            'TypeUrl', // param base name
            'MediaTypeUrl', // openApiType
            'form', // style
            true, // explode
            true // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $index,
            'Index', // param base name
            'integer', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);




        $headers = $this->headerSelector->selectHeaders(
            [],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (isset($body)) {
            if (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the body
                $httpBody = \GuzzleHttp\Utils::jsonEncode(ObjectSerializer::sanitizeForSerialization($body));
            } else {
                $httpBody = $body;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'PUT',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
